__gnu_cxx::bitmap_allocator< _Tp >(3cxx)

NAME
__gnu_cxx::bitmap_allocator< _Tp > - Bitmap Allocator, primary template.

SYNOPSIS

  Public Types

typedef free_list::__mutex_type __mutex_type
typedef ptrdiff_t difference_type
typedef _Tp * pointer
typedef std::true_type propagate_on_container_move_assignment
typedef _Tp & reference
typedef size_t size_type
typedef _Tp value_type

  Public Member Functions

bitmap_allocator (const bitmap_allocator &) noexcept
template<typename _Tp1 > bitmap_allocator (const bitmap_allocator< _Tp1 > &) noexcept
pointer _M_allocate_single_object ()
Allocates memory for a single object of size sizeof(_Tp).
void _M_deallocate_single_object (pointer __p) throw ()
Deallocates memory that belongs to a single object of size sizeof(_Tp).
const_pointer address (const_reference __r) const noexcept
pointer address (reference __r) const noexcept
pointer allocate (size_type __n)
pointer allocate (size_type __n, typename bitmap_allocator< void >::const_pointer)
template<typename _Up , typename... _Args> void construct (_Up *__p, _Args &&... __args)
void deallocate (pointer __p, size_type __n) throw ()
template<typename _Up > void destroy (_Up *__p)
size_type max_size () const noexcept

  Public Attributes

const typedef _Tp * const_pointer
const typedef _Tp & const_reference

Detailed Description

  template<typename _Tp>
class __gnu_cxx::bitmap_allocator< _Tp >" Bitmap Allocator, primary template.

Definition at line 660 of file bitmap_allocator.h.

Member Function Documentation

  template<typename _Tp > pointer __gnu_cxx::bitmap_allocator< _Tp >::_M_allocate_single_object () [inline]

Allocates memory for a single object of size sizeof(_Tp).

Exceptions
    std::bad_alloc. If memory can not be allocated.

Complexity: Worst case complexity is O(N), but that is hardly ever hit. If and when this particular case is encountered, the next few cases are guaranteed to have a worst case complexity of O(1)! That's why this function performs very well on average. You can consider this function to have a complexity referred to commonly as: Amortized Constant time.

Definition at line 824 of file bitmap_allocator.h.

References __gnu_cxx::__detail::__bit_allocate(), __gnu_cxx::__detail::__num_bitmaps(), and __gnu_cxx::_Bit_scan_forward().

  template<typename _Tp > void __gnu_cxx::bitmap_allocator< _Tp >::_M_deallocate_single_object (pointer __p) [inline]

Deallocates memory that belongs to a single object of size sizeof(_Tp). Complexity: O(lg(N)), but the worst case is not hit often! This is because containers usually deallocate memory close to each other and this case is handled in O(1) time by the deallocate function.

Definition at line 914 of file bitmap_allocator.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.